fediverser/apps/core/urls.py
from django.urls import path

from . import views

app_name = "fediverser-core"

urlpatterns = [
    path("", views.HomeView.as_view(), name="portal-home"),
    path(
        "reddit/invites/<str:key>/accept",
        views.RedditorAcceptInviteView.as_view(),
        name="redditor-accept-invite",
    ),
    path(
        "reddit/invites/<str:key>/decline",
        views.RedditorDeclineInviteView.as_view(),
        name="redditor-decline-invite",
    ),
    path("reddit/connect", views.RedditConnectionView.as_view(), name="reddit-connection-setup"),
    path("reddit/login", views.RedditLoginView.as_view(), name="reddit-login"),
    path("lemmy/connect", views.LemmySignupView.as_view(), name="lemmy-connect-setup"),
    path("lemmy/set-password", views.LemmySetPasswordView.as_view(), name="lemmy-set-password"),
    path("activity", views.UserActionListView.as_view(), name="activity-list"),
    path("instances", views.InstanceListView.as_view(), name="instance-list"),
    path("instances/create", views.InstanceCreateView.as_view(), name="instance-create"),
    path("instances/find", views.InstanceFinderView.as_view(), name="instance-find"),
    path("instances/<str:domain>", views.InstanceDetailView.as_view(), name="instance-detail"),
    path(
        "instances/<str:domain>/recommend/category",
        views.InstanceCategoryRecommendationCreateView.as_view(),
        name="instance-categoryrecommendation-create",
    ),
    path(
        "instances/<str:domain>/recommend/country",
        views.InstanceCountryRecommendationCreateView.as_view(),
        name="instance-countryrecommendation-create",
    ),
    path(
        "instances/<str:domain>/annotate/closed",
        views.InstanceClosedAnnotationCreateView.as_view(),
        name="instance-closedannotation-create",
    ),
    path(
        "instances/<str:domain>/annotate/abandoned",
        views.InstanceAbandonedAnnotationCreateView.as_view(),
        name="instance-abandonedannotation-create",
    ),
    path("communities", views.CommunityListView.as_view(), name="community-list"),
    path(
        "communities/create",
        views.CommunityCreateView.as_view(),
        name="community-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>",
        views.CommunityDetailView.as_view(),
        name="community-detail",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/repost/reddit",
        views.CommunityRepostRedditSubmissionView.as_view(),
        name="community-repost-reddit",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/recommend/category",
        views.CommunityCategoryRecommendationCreateView.as_view(),
        name="community-categoryrecommendation-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/ambassadors/apply",
        views.CommunityAmbassadorApplicationCreateView.as_view(),
        name="community-ambassador-application-create",
    ),
    path(
        "communities/<str:name>@<str:instance_domain>/feeds/create",
        views.CommunityFeedCreateView.as_view(),
        name="community-contentfeed-create",
    ),
    path(
        "reddit/submissions/<str:submission_id>",
        views.RedditSubmissionView.as_view(),
        name="redditsubmission-detail",
    ),
    path("subreddits", views.SubredditListView.as_view(), name="subreddit-list"),
    path("subreddits/create", views.SubredditCreateView.as_view(), name="subreddit-create"),
    path("subreddits/<str:name>", views.SubredditDetailView.as_view(), name="subreddit-detail"),
    path(
        "subreddits/<str:name>/subscribe", views.subscribe_to_subreddit, name="subreddit-subscribe"
    ),
    path(
        "subreddits/<str:name>/unsubscribe",
        views.unsubscribe_from_subreddit,
        name="subreddit-unsubscribe",
    ),
    path(
        "subreddits/<str:name>/recommend/category",
        views.SubredditCategoryRecommendationCreateView.as_view(),
        name="subreddit-categoryrecommendation-create",
    ),
    path(
        "subreddits/<str:name>/recommend/alternative",
        views.SubredditAlternativeRecommendationCreateView.as_view(),
        name="subreddit-alternativerecommendation-create",
    ),
    path(
        "subreddits/<str:name>/request/community",
        views.CommunityRequestCreateView.as_view(),
        name="subreddit-communityrequest-create",
    ),
    path("redditors", views.RedditorListView.as_view(), name="redditor-list"),
    path("redditors/<str:username>", views.RedditorDetailView.as_view(), name="redditor-detail"),
    path(
        "redditors/<str:username>/invite",
        views.RedditorInviteView.as_view(),
        name="redditor-send-invite",
    ),
    path(
        "api/community-requests",
        views.CommunityRequestListView.as_view(),
        name="api-community-request-list",
    ),
    path(
        "api/subreddits",
        views.RedditCommunityListView.as_view(),
        name="api-subreddit-list",
    ),
    path("api/nodeinfo", views.NodeInfoView.as_view(), name="nodeinfo-detail"),
    path(
        "api/fediverser-instances",
        views.FediversedInstanceListView.as_view(),
        name="fediverserinstance-list",
    ),
    path(
        "api/instance/recommendations",
        views.InstanceRecommendationsListView.as_view(),
        name="api-instancerecommendation-list",
    ),
    path(
        "api/changes",
        views.ChangeFeedEntryListView.as_view(),
        name="changefeedentry-list",
    ),
    path(
        "api/changes/<int:pk>",
        views.ChangeFeedEntryDetailView.as_view(),
        name="changefeedentry-detail",
    ),
    path("feed/changes", views.ChangeFeed(), name="changefeed-feed"),
]

fediverser/apps/core/templates/portal/reddit_community/create.tmpl.html
{% extends "portal/generic/form.tmpl.html" %}

{% block actions %}
<input type="submit" value="Submit" class="button" />
{% endblock %}

fediverser/apps/core/templates/portal/reddit_community/detail.tmpl.html
{% extends "portal/base.tmpl.html" %}
{% load fediverser %}


{% block main_header %}
{% include "portal/reddit_community/header.tmpl.html" with title=page_title subtitle=page_subtitle action_url=header_action_url action_text=header_action_label icon=header_icon subreddit=object %}
{% endblock %}

{% block main_content %}
<dl>
  <dt>Subreddit Page</dt>
  <dd><a href="{{ object.full_reddit_url }}"}} target="_blank">/r/{{ object.name }}</a></dd>
  {% if object.annotation.category %}
  <dt>Category</dt>
  <dd>{{ object.annotation.category.name }}</dd>
  {% endif %}
{% if object.recommendations.exists %}
  <dt>Recommended Alternatives</dt>
  <dd>
    <ul>
      {% for recommendation in object.recommendations.all %}
      <li>
        <a href="{{ recommendation.community.url }}">{{ recommendation.community.fqdn }}</a>
      </li>
      {% endfor %}
    </ul>
  </dd>
  {% endif %}
  {% if object.has_unresolved_community_requests and not object.annotation.locked %}
  <dt>Community Creation Requests</dt>
  <dd>
    Instances that have been requested to create a community to replace /r/{{object.name }}
    <ul>
      {% for request in object.unfulfilled_community_requests.all %}
      <li>
        <a href="{{ request.instance.url }}">{{ request.instance.domain }}</a>
      </li>
      {% endfor %}
    </ul>
  </dd>
  {% endif %}

</dl>

<hr />


{% if not object.annotation.locked %}

{% if not object.annotation.category %}
<h3>Category</h3>
{% if not user|pending_category_proposal:object %}
<p>This subreddit has not been properly categorized yet. Please indicate the category which best describes it:</p>
<form action="{% url 'fediverser-core:subreddit-categoryrecommendation-create' name=object.name %}" method="POST" novalidate>
  {% csrf_token %}
  <ul class="fields">
    {% for field in category_picker_form.visible_fields %}
    <li>
      {% include "wagtailadmin/shared/field.html" %}
    </li>
    {% endfor %}
    <li>
      <input type="submit" value="Submit Category" class="button" />
    </li>
  </ul>
</form>
{% else %}
<p>You already recommended a category! Please check your <a href="{% url 'fediverser-core:activity-list' %}">activity page</a> for more information.</p>
{% endif %}
{% endif %}

<h3>Recommended Alternative</h3>
{% if user|has_pending_community_recommendations:object %}
<h4>Pending Proposals</h4>
<ul>
  {% for proposal in user|pending_community_recommendations:object %}
  <li>{{ proposal.description }}</li>
  {% endfor %}
</ul>
{% else %}
<p>Is there any Lemmy community that should be added as an alternative to {{ object.name }}?</p>
<form action="{% url 'fediverser-core:subreddit-alternativerecommendation-create' name=object.name %}" method="POST" novalidate>
  {% csrf_token %}
  <ul class="fields">
    {% for field in recommended_alternative_form.visible_fields %}
    <li>
      {% include "wagtailadmin/shared/field.html" %}
    </li>
    {% endfor %}
    <li>
      <input type="submit" value="Submit Alternative" class="button" />
    </li>
  </ul>
</form>
{% endif %}

{% if object|is_missing_community_recommendations %}
<h3>Request Community Creation</h3>
<p>If there is no alternative has been created yet, you may request one to be created at the participating instances. Which instance could be a good home to {{ object.name }}?</p>

<form action="{% url 'fediverser-core:subreddit-communityrequest-create' name=object.name %}" method="POST" novalidate>
  {% csrf_token %}
  <ul class="fields">
    {% for field in community_request_form.visible_fields %}
    <li>
      {% include "wagtailadmin/shared/field.html" %}
    </li>
    {% endfor %}
    <li>
      <input type="submit" value="Submit Community Request" class="button" />
    </li>
  </ul>
</form>
{% endif %}


{% endif %}
{% endblock %}

{% block extra_js %}
{{ block.super }}
{{ category_picker_form.media.js }}
{% endblock %}


{% block extra_css %}
{{ block.super }}
{{ category_picker_form.media.css }}
{% endblock %}

fediverser/apps/core/templates/portal/reddit_community/header.tmpl.html
{% extends "portal/partials/header.tmpl.html" %}
{% load wagtailadmin_tags fediverser %}

{% block right_column %}
<div class="actionbutton">
  <form action="{{ action_url }}" method="POST" novalidate>
    {% csrf_token %}
    {% with header_action_icon as action_icon_name %}
    <button class="button bicolor button--icon">{% icon name=action_icon_name wrapped=1 %}{{ action_text|capfirst }}</button>
    {% endwith %}
  </form>
</div>
{% endblock %}

fediverser/apps/core/templates/portal/reddit_community/list.tmpl.html
{% extends "portal/generic/listing.tmpl.html" %}
{% load i18n account wagtailadmin_tags fediverser %}

{% block listing %}
<table class="listing listing--inline-actions">
  <thead>
    <tr>
      <th scope="col">Name</th>
      <th scope="col">Category</th>
      <th scope="col">Recommended Alternatives</th>
    </tr>
  </thead>
  <tbody>
    {% for subreddit in object_list %}
    <tr>
      <td class="title">
        <div class="title-wrapper">
          <a href="{% url 'fediverser-core:subreddit-detail' name=subreddit.name %}">
            {{ subreddit.name }}
          </a>
        </div>
      </td>
      <td>
        {% if subreddit.annotation and subreddit.annotation.category %}
        {{ subreddit.annotation.category }}
        {% else %}
        <form action="{% url 'fediverser-core:subreddit-categoryrecommendation-create' name=subreddit.name %}" method="POST" name="bulk_category_picker" novalidate>
          {% csrf_token %}
          <ul class="fields">
            {% for field in category_picker_form.visible_fields %}
            <li>
              {% include "wagtailadmin/shared/field.html" %}
            </li>
            {% endfor %}
          </ul>
        </form>
        {% endif %}
      </td>
      <td>
        <ul>
          {% for recommendation in subreddit.recommendations.all %}
          <li><a href="{{ recommendation.community.url }}" target="_blank">!{{ recommendation.community.fqdn }}</a></li>
          {% endfor %}
          {% for community in subreddit.candidate_communities %}
          <li><a href="{{ community.url }}" target="_blank">!{{ community.fqdn }} (Pending Review)</a></li>
          {% endfor %}
          {% if not subreddit.annotation.locked %}
          <li>
            <a href="{% url 'fediverser-core:subreddit-alternativerecommendation-create' name=subreddit.name %}">
              Recommend a community
            </a>
          </li>
          {% if subreddit|is_missing_community_recommendations %}
          <a href="{% url 'fediverser-core:subreddit-communityrequest-create' name=subreddit.name %}">
            Request the creation of new community
          </a>
          {% endif %}

          {% endif %}
        </ul>
      </td>
    </tr>
    {% endfor %}
  </tbody>
</table>
{% endblock %}


{% block extra_js %}
{{ block.super }}
<script type="text/javascript">
 function submitSelection(selectNodes, attribute) {
   selectNodes.forEach(function(elem) {
     elem.addEventListener('change', function(evt) {
       const form = evt.target.closest("form");
       const cell = evt.target.closest("td");
       const csrfToken = form.querySelector('input[name="csrfmiddlewaretoken"]')
       const url = form.getAttribute("action");
       const formData = new FormData();

       const optionNode = evt.target.querySelector(`option[value="${evt.target.value}"]`);

       formData.append("csrfmiddlewaretoken", csrfToken.value);
       formData.append(attribute, evt.target.value);

       fetch(url, {
         method: 'POST',
         body: formData
       }).then(response => cell.textContent = optionNode.text);
     })
   });
 }

 window.addEventListener('load', function(){
   let categoryPickers = document.querySelectorAll("form[name=bulk_category_picker] select");
   let statusPickers = document.querySelectorAll("form[name=bulk_status_picker] select");
   let lockCheckboxes = document.querySelectorAll("table input[type=checkbox]");
   submitSelection(categoryPickers, "category");
   submitSelection(statusPickers, "community_status");

   lockCheckboxes.forEach(function(elem) {
     elem.addEventListener("change", function(evt) {
       const url = elem.getAttribute("data-url");
       const method = elem.checked ? "POST" : "DELETE";

       fetch(url, {method: method});
     });
   });
 });
</script>
{% endblock %}

{% block extra_css %}
{{ block.super }}
<style>
 table form[name=bulk_category_picker] label,  table form[name=bulk_status_picker] label {
     display: none;
 }
 table form select {
     max-width: 80px;
 }

 label[for=id_search], div.w-field.w-field--char_field.w-field--text_input[data-contentpath=search] {
     display: none;
 }
</style>
{% endblock %}